package com.xhkjedu.sexam.mapper.paper;

import com.xhkjedu.sexam.model.paperstudent.EPaperStudentQuestion;
import com.xhkjedu.sexam.vo.paper.EPaperSQuestionVo;
import com.xhkjedu.sexam.vo.paper.EPaperVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface EPaperCorrectTeacherMapper {
    //待阅卷列表
    List<Map> listPending(@Param("teacherid") Integer teacherid);

    //已阅卷列表
    List<Map> listMarked(@Param("teacherid") Integer teacherid);

    //随机获取一条待批阅试题
    EPaperSQuestionVo getCorrectQuestion(@Param("teacherid") Integer teacherid,
                                         @Param("eptqid") Integer eptqid, @Param("classids") String classids);

    //试题批阅情况
    EPaperSQuestionVo getCheckQuestion(@Param("eptqid") Integer eptqid, @Param("teacherid") Integer teacherid);

    //修改试卷学生试题为批阅中
    void updateCheckQuestionById(@Param("epsqid") Integer epsqid, @Param("teacherid") Integer teacherid);

    //获取上一份批阅试题
    EPaperSQuestionVo getPreQuestion(@Param("eptqid") Integer eptqid, @Param("teacherid") Integer teacherid);

    //阅卷记录
    List<Map> listRecord(@Param("eptqid") Integer eptqid, @Param("teacherid") Integer teacherid);

    //批阅试题
    void correctQuestion(@Param("psq") EPaperStudentQuestion psq);

    //学生未批改试题数量
    Integer getNotCorrect(@Param("epsid") Integer epsid);

    //修改学生试卷批阅状态
    void updateCheckStuById(@Param("epsid") Integer epsid, @Param("checkid") Integer checkid);

    //根据考试科目id获取考试名称
    Map getExamNameByEsId(@Param("esid") Integer esid);

    //获取考试试卷
    List<EPaperVo> listPaperByExamId(@Param("examid") Integer examid);

    //获取考试学生试题
    List<EPaperStudentQuestion> listStuQuestionByEpids(@Param("epids") String epids);

    //获取试卷试题题号
    List<Map> listQnByEpId(@Param("epid") Integer epid);
}