package com.xhkjedu.sstudy.service.question;

import com.xhkjedu.sstudy.mapper.question.QuestionMapper;
import com.xhkjedu.sstudy.mapper.question.UserBasketMapper;
import com.xhkjedu.sstudy.mapper.subjectbook.SubjectMapper;
import com.xhkjedu.sstudy.model.question.TUserBasket;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.sstudy.vo.question.QuestionVo;
import com.xhkjedu.sstudy.vo.question.UserBasketVo;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author ywx
 * @classname UserBasketService
 * @description 
 * @date 2020/6/9 10:49
 **/
@Service
public class UserBasketService {
    @Resource
    private UserBasketMapper userBasketMapper;
    @Resource
    private QuestionMapper questionMapper;
    @Resource
    private SubjectMapper subjectMapper;

    //添加
    public Integer save(TUserBasket model) {
        Integer ubid = userBasketMapper.getUbidByUserIdQuestionId(model.getUserid(),model.getQuestionid());
        if (N_Utils.isEmptyInteger(ubid)) {
            model.setCreatetime(N_Utils.getSecondTimestamp());
            userBasketMapper.insertUseGeneratedKeys(model);
            questionMapper.updateCount(model.getQuestionid());//更新组题次数
            ubid = model.getId();
        }
        return ubid;
    }

    //删除
    public Integer deleteById(Integer userid,String questionid) {
       // return userBasketMapper.deleteByPrimaryKey(ubid);
        return userBasketMapper.deleteByQuestioniduid(userid,questionid);
    }

    /**
     * 清空试题篮
     * @Param [userid, subjectid]
     * @Author ywx
     * @Date 2020/6/9 10:54
     * @return java.lang.Integer
     **/
    public Integer deleteBySubjectId(Integer userid, String subjectid) {
        return userBasketMapper.deleteBySubjectId(userid, subjectid);
    }

    //获取列表
    public List <UserBasketVo> findAll(Integer userid, String subjectid) {
        List<UserBasketVo> baskets = userBasketMapper.findAll(userid, subjectid);
        String sujectname = subjectMapper.getSubjectnameById(subjectid);
        //英语学科时处理听力题
        if(sujectname.contains("英语")){
            List<QuestionVo> hearqs  = new ArrayList<>();
            for (UserBasketVo b : baskets) {
                List<QuestionVo> questions = b.getQuestions();

                List<QuestionVo> tllist = questions.stream().filter( o -> o.getHashear() ==1).collect(Collectors.toList());
                if(N_Utils.isListNotEmpty(tllist)){
                    hearqs.addAll(tllist);

                    questions = questions.stream().filter( o -> o.getHashear() ==0).collect(Collectors.toList());
                }
                b.setPtnum(questions.size());
                Double scoretotal = questions.stream().collect(Collectors.summingDouble(QuestionVo::getScore));
                b.setPtscore(scoretotal);
                b.setQuestions(questions);
            }

            if(N_Utils.isListNotEmpty(hearqs)){
                UserBasketVo tlvo = new UserBasketVo();
                tlvo.setQtypeid("tlt");
                tlvo.setQtypename("听力题");
                tlvo.setPtnum(hearqs.size());
                Double scoretotal = hearqs.stream().collect(Collectors.summingDouble(QuestionVo::getScore));
                tlvo.setPtscore(scoretotal);
                tlvo.setQuestions(hearqs);
                baskets.add(0,tlvo);
            }
        }else{
            for (UserBasketVo b : baskets) {
                List<QuestionVo> questions = b.getQuestions();
                b.setPtnum(questions.size());
                Double scoretotal = questions.stream().collect(Collectors.summingDouble(QuestionVo::getScore));
                b.setPtscore(scoretotal);
            }
        }
        return baskets;
    }

    /**
     * 删除题型下指定试题
     * @Param [userid, qtypeid]
     * @Author ywx
     * @Date 2020/6/9 11:06
     * @return java.lang.Integer
     **/
    public Integer deleteByTypeId(Integer userid, String qtypeid) {
        return userBasketMapper.deleteByTypeId(userid, qtypeid);
    }
}
